/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class Representing Detector Evidence used for analysis
 *
 */
class AnalysisData {
  /**
   * Create a AnalysisData.
   * @member {string} [source] Name of the Detector
   * @member {object} [detectorDefinition] Detector Definition
   * @member {string} [detectorDefinition.displayName] Display name of the
   * detector
   * @member {string} [detectorDefinition.description] Description of the
   * detector
   * @member {number} [detectorDefinition.rank] Detector Rank
   * @member {boolean} [detectorDefinition.isEnabled] Flag representing whether
   * detector is enabled or not.
   * @member {array} [metrics] Source Metrics
   * @member {array} [data] Additional Source Data
   * @member {object} [detectorMetaData] Detector Meta Data
   * @member {object} [detectorMetaData.dataSource] Source of the Data
   * @member {array} [detectorMetaData.dataSource.instructions] Instrunctions
   * if any for the data source
   * @member {array} [detectorMetaData.dataSource.dataSourceUri] Datasource Uri
   * Links
   */
  constructor() {
  }

  /**
   * Defines the metadata of AnalysisData
   *
   * @returns {object} metadata of AnalysisData
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AnalysisData',
      type: {
        name: 'Composite',
        className: 'AnalysisData',
        modelProperties: {
          source: {
            required: false,
            serializedName: 'source',
            type: {
              name: 'String'
            }
          },
          detectorDefinition: {
            required: false,
            serializedName: 'detectorDefinition',
            type: {
              name: 'Composite',
              className: 'DetectorDefinition'
            }
          },
          metrics: {
            required: false,
            serializedName: 'metrics',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'DiagnosticMetricSetElementType',
                  type: {
                    name: 'Composite',
                    className: 'DiagnosticMetricSet'
                  }
              }
            }
          },
          data: {
            required: false,
            serializedName: 'data',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ArrayElementType',
                  type: {
                    name: 'Sequence',
                    element: {
                        required: false,
                        serializedName: 'NameValuePairElementType',
                        type: {
                          name: 'Composite',
                          className: 'NameValuePair'
                        }
                    }
                  }
              }
            }
          },
          detectorMetaData: {
            required: false,
            serializedName: 'detectorMetaData',
            type: {
              name: 'Composite',
              className: 'ResponseMetaData'
            }
          }
        }
      }
    };
  }
}

module.exports = AnalysisData;
