/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Application stack.
 *
 */
class ApplicationStack {
  /**
   * Create a ApplicationStack.
   * @member {string} [name] Application stack name.
   * @member {string} [display] Application stack display name.
   * @member {string} [dependency] Application stack dependency.
   * @member {array} [majorVersions] List of major versions available.
   * @member {array} [frameworks] List of frameworks associated with
   * application stack.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ApplicationStack
   *
   * @returns {object} metadata of ApplicationStack
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApplicationStack',
      type: {
        name: 'Composite',
        className: 'ApplicationStack',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          display: {
            required: false,
            serializedName: 'display',
            type: {
              name: 'String'
            }
          },
          dependency: {
            required: false,
            serializedName: 'dependency',
            type: {
              name: 'String'
            }
          },
          majorVersions: {
            required: false,
            serializedName: 'majorVersions',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StackMajorVersionElementType',
                  type: {
                    name: 'Composite',
                    className: 'StackMajorVersion'
                  }
              }
            }
          },
          frameworks: {
            required: false,
            serializedName: 'frameworks',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ApplicationStackElementType',
                  type: {
                    name: 'Composite',
                    className: 'ApplicationStack'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ApplicationStack;
