/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Http logs to azure blob storage configuration.
 *
 */
class AzureBlobStorageHttpLogsConfig {
  /**
   * Create a AzureBlobStorageHttpLogsConfig.
   * @member {string} [sasUrl] SAS url to a azure blob container with
   * read/write/list/delete permissions.
   * @member {number} [retentionInDays] Retention in days.
   * Remove blobs older than X days.
   * 0 or lower means no retention.
   * @member {boolean} [enabled] True if configuration is enabled, false if it
   * is disabled and null if configuration is not set.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AzureBlobStorageHttpLogsConfig
   *
   * @returns {object} metadata of AzureBlobStorageHttpLogsConfig
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureBlobStorageHttpLogsConfig',
      type: {
        name: 'Composite',
        className: 'AzureBlobStorageHttpLogsConfig',
        modelProperties: {
          sasUrl: {
            required: false,
            serializedName: 'sasUrl',
            type: {
              name: 'String'
            }
          },
          retentionInDays: {
            required: false,
            serializedName: 'retentionInDays',
            type: {
              name: 'Number'
            }
          },
          enabled: {
            required: false,
            serializedName: 'enabled',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureBlobStorageHttpLogsConfig;
