/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * AzureStorageInfo dictionary resource.
 *
 * @extends models['ProxyOnlyResource']
 */
class AzureStoragePropertyDictionaryResource extends models['ProxyOnlyResource'] {
  /**
   * Create a AzureStoragePropertyDictionaryResource.
   * @member {object} [properties] Azure storage accounts.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AzureStoragePropertyDictionaryResource
   *
   * @returns {object} metadata of AzureStoragePropertyDictionaryResource
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureStoragePropertyDictionaryResource',
      type: {
        name: 'Composite',
        className: 'AzureStoragePropertyDictionaryResource',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: false,
            serializedName: 'kind',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'AzureStorageInfoValueElementType',
                  type: {
                    name: 'Composite',
                    className: 'AzureStorageInfoValue'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = AzureStoragePropertyDictionaryResource;
