/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Application logs to Azure table storage configuration.
 *
 */
class AzureTableStorageApplicationLogsConfig {
  /**
   * Create a AzureTableStorageApplicationLogsConfig.
   * @member {string} [level] Log level. Possible values include: 'Off',
   * 'Verbose', 'Information', 'Warning', 'Error'
   * @member {string} sasUrl SAS URL to an Azure table with add/query/delete
   * permissions.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AzureTableStorageApplicationLogsConfig
   *
   * @returns {object} metadata of AzureTableStorageApplicationLogsConfig
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureTableStorageApplicationLogsConfig',
      type: {
        name: 'Composite',
        className: 'AzureTableStorageApplicationLogsConfig',
        modelProperties: {
          level: {
            required: false,
            serializedName: 'level',
            type: {
              name: 'Enum',
              allowedValues: [ 'Off', 'Verbose', 'Information', 'Warning', 'Error' ]
            }
          },
          sasUrl: {
            required: true,
            serializedName: 'sasUrl',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureTableStorageApplicationLogsConfig;
