/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes the capabilities/features allowed for a specific SKU.
 *
 */
class Capability {
  /**
   * Create a Capability.
   * @member {string} [name] Name of the SKU capability.
   * @member {string} [value] Value of the SKU capability.
   * @member {string} [reason] Reason of the SKU capability.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Capability
   *
   * @returns {object} metadata of Capability
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Capability',
      type: {
        name: 'Composite',
        className: 'Capability',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          value: {
            required: false,
            serializedName: 'value',
            type: {
              name: 'String'
            }
          },
          reason: {
            required: false,
            serializedName: 'reason',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = Capability;
