/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * SSL certificate email.
 *
 * @extends models['ProxyOnlyResource']
 */
class CertificateEmail extends models['ProxyOnlyResource'] {
  /**
   * Create a CertificateEmail.
   * @member {string} [emailId] Email id.
   * @member {date} [timeStamp] Time stamp.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of CertificateEmail
   *
   * @returns {object} metadata of CertificateEmail
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CertificateEmail',
      type: {
        name: 'Composite',
        className: 'CertificateEmail',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: false,
            serializedName: 'kind',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          emailId: {
            required: false,
            serializedName: 'properties.emailId',
            type: {
              name: 'String'
            }
          },
          timeStamp: {
            required: false,
            serializedName: 'properties.timeStamp',
            type: {
              name: 'DateTime'
            }
          }
        }
      }
    };
  }
}

module.exports = CertificateEmail;
