/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Database connection string value to type pair.
 *
 */
class ConnStringValueTypePair {
  /**
   * Create a ConnStringValueTypePair.
   * @member {string} value Value of pair.
   * @member {string} type Type of database. Possible values include: 'MySql',
   * 'SQLServer', 'SQLAzure', 'Custom', 'NotificationHub', 'ServiceBus',
   * 'EventHub', 'ApiHub', 'DocDb', 'RedisCache', 'PostgreSQL'
   */
  constructor() {
  }

  /**
   * Defines the metadata of ConnStringValueTypePair
   *
   * @returns {object} metadata of ConnStringValueTypePair
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ConnStringValueTypePair',
      type: {
        name: 'Composite',
        className: 'ConnStringValueTypePair',
        modelProperties: {
          value: {
            required: true,
            serializedName: 'value',
            type: {
              name: 'String'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'Enum',
              allowedValues: [ 'MySql', 'SQLServer', 'SQLAzure', 'Custom', 'NotificationHub', 'ServiceBus', 'EventHub', 'ApiHub', 'DocDb', 'RedisCache', 'PostgreSQL' ]
            }
          }
        }
      }
    };
  }
}

module.exports = ConnStringValueTypePair;
