/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Continuous Web Job Information.
 *
 * @extends models['ProxyOnlyResource']
 */
class ContinuousWebJob extends models['ProxyOnlyResource'] {
  /**
   * Create a ContinuousWebJob.
   * @member {string} [status] Job status. Possible values include:
   * 'Initializing', 'Starting', 'Running', 'PendingRestart', 'Stopped'
   * @member {string} [detailedStatus] Detailed status.
   * @member {string} [logUrl] Log URL.
   * @member {string} [runCommand] Run command.
   * @member {string} [url] Job URL.
   * @member {string} [extraInfoUrl] Extra Info URL.
   * @member {string} [webJobType] Job type. Possible values include:
   * 'Continuous', 'Triggered'
   * @member {string} [error] Error information.
   * @member {boolean} [usingSdk] Using SDK?
   * @member {object} [settings] Job settings.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ContinuousWebJob
   *
   * @returns {object} metadata of ContinuousWebJob
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ContinuousWebJob',
      type: {
        name: 'Composite',
        className: 'ContinuousWebJob',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: false,
            serializedName: 'kind',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          status: {
            required: false,
            serializedName: 'properties.status',
            type: {
              name: 'Enum',
              allowedValues: [ 'Initializing', 'Starting', 'Running', 'PendingRestart', 'Stopped' ]
            }
          },
          detailedStatus: {
            required: false,
            serializedName: 'properties.detailed_status',
            type: {
              name: 'String'
            }
          },
          logUrl: {
            required: false,
            serializedName: 'properties.log_url',
            type: {
              name: 'String'
            }
          },
          runCommand: {
            required: false,
            serializedName: 'properties.run_command',
            type: {
              name: 'String'
            }
          },
          url: {
            required: false,
            serializedName: 'properties.url',
            type: {
              name: 'String'
            }
          },
          extraInfoUrl: {
            required: false,
            serializedName: 'properties.extra_info_url',
            type: {
              name: 'String'
            }
          },
          webJobType: {
            required: false,
            serializedName: 'properties.web_job_type',
            type: {
              name: 'Enum',
              allowedValues: [ 'Continuous', 'Triggered' ]
            }
          },
          error: {
            required: false,
            serializedName: 'properties.error',
            type: {
              name: 'String'
            }
          },
          usingSdk: {
            required: false,
            serializedName: 'properties.using_sdk',
            type: {
              name: 'Boolean'
            }
          },
          settings: {
            required: false,
            serializedName: 'properties.settings',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'ObjectElementType',
                  type: {
                    name: 'Object'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ContinuousWebJob;
