/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Object with a list of the resources that need to be moved and the resource
 * group they should be moved to.
 *
 */
class CsmMoveResourceEnvelope {
  /**
   * Create a CsmMoveResourceEnvelope.
   * @member {string} [targetResourceGroup]
   * @member {array} [resources]
   */
  constructor() {
  }

  /**
   * Defines the metadata of CsmMoveResourceEnvelope
   *
   * @returns {object} metadata of CsmMoveResourceEnvelope
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CsmMoveResourceEnvelope',
      type: {
        name: 'Composite',
        className: 'CsmMoveResourceEnvelope',
        modelProperties: {
          targetResourceGroup: {
            required: false,
            serializedName: 'targetResourceGroup',
            constraints: {
              MaxLength: 90,
              MinLength: 1,
              Pattern: ' ^[-\w\._\(\)]+[^\.]$'
            },
            type: {
              name: 'String'
            }
          },
          resources: {
            required: false,
            serializedName: 'resources',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = CsmMoveResourceEnvelope;
