/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Collection of Azure resource manager operation metadata.
 */
class CsmOperationCollection extends Array {
  /**
   * Create a CsmOperationCollection.
   * @member {string} [nextLink] Link to next page of resources.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of CsmOperationCollection
   *
   * @returns {object} metadata of CsmOperationCollection
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CsmOperationCollection',
      type: {
        name: 'Composite',
        className: 'CsmOperationCollection',
        modelProperties: {
          value: {
            required: true,
            serializedName: '',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'CsmOperationDescriptionElementType',
                  type: {
                    name: 'Composite',
                    className: 'CsmOperationDescription'
                  }
              }
            }
          },
          nextLink: {
            required: false,
            readOnly: true,
            serializedName: 'nextLink',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = CsmOperationCollection;
