/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Description of an operation available for Microsoft.Web resource provider.
 *
 */
class CsmOperationDescription {
  /**
   * Create a CsmOperationDescription.
   * @member {string} [name]
   * @member {object} [display]
   * @member {string} [display.provider]
   * @member {string} [display.resource]
   * @member {string} [display.operation]
   * @member {string} [display.description]
   * @member {string} [origin]
   * @member {object} [properties]
   * @member {object} [properties.serviceSpecification]
   * @member {array} [properties.serviceSpecification.metricSpecifications]
   * @member {array} [properties.serviceSpecification.logSpecifications]
   */
  constructor() {
  }

  /**
   * Defines the metadata of CsmOperationDescription
   *
   * @returns {object} metadata of CsmOperationDescription
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CsmOperationDescription',
      type: {
        name: 'Composite',
        className: 'CsmOperationDescription',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          display: {
            required: false,
            serializedName: 'display',
            type: {
              name: 'Composite',
              className: 'CsmOperationDisplay'
            }
          },
          origin: {
            required: false,
            serializedName: 'origin',
            type: {
              name: 'String'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'CsmOperationDescriptionProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = CsmOperationDescription;
