/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Publishing options for requested profile.
 *
 */
class CsmPublishingProfileOptions {
  /**
   * Create a CsmPublishingProfileOptions.
   * @member {string} [format] Name of the format. Valid values are:
   * FileZilla3
   * WebDeploy -- default
   * Ftp. Possible values include: 'FileZilla3', 'WebDeploy', 'Ftp'
   * @member {boolean} [includeDisasterRecoveryEndpoints] Include the
   * DisasterRecover endpoint if true
   */
  constructor() {
  }

  /**
   * Defines the metadata of CsmPublishingProfileOptions
   *
   * @returns {object} metadata of CsmPublishingProfileOptions
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CsmPublishingProfileOptions',
      type: {
        name: 'Composite',
        className: 'CsmPublishingProfileOptions',
        modelProperties: {
          format: {
            required: false,
            serializedName: 'format',
            type: {
              name: 'String'
            }
          },
          includeDisasterRecoveryEndpoints: {
            required: false,
            serializedName: 'includeDisasterRecoveryEndpoints',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = CsmPublishingProfileOptions;
