/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Deployment slot parameters.
 *
 */
class CsmSlotEntity {
  /**
   * Create a CsmSlotEntity.
   * @member {string} targetSlot Destination deployment slot during swap
   * operation.
   * @member {boolean} preserveVnet <code>true</code> to preserve Virtual
   * Network to the slot during swap; otherwise, <code>false</code>.
   */
  constructor() {
  }

  /**
   * Defines the metadata of CsmSlotEntity
   *
   * @returns {object} metadata of CsmSlotEntity
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CsmSlotEntity',
      type: {
        name: 'Composite',
        className: 'CsmSlotEntity',
        modelProperties: {
          targetSlot: {
            required: true,
            serializedName: 'targetSlot',
            type: {
              name: 'String'
            }
          },
          preserveVnet: {
            required: true,
            serializedName: 'preserveVnet',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = CsmSlotEntity;
