/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Usage of the quota resource.
 *
 */
class CsmUsageQuota {
  /**
   * Create a CsmUsageQuota.
   * @member {string} [unit] Units of measurement for the quota resourse.
   * @member {date} [nextResetTime] Next reset time for the resource counter.
   * @member {number} [currentValue] The current value of the resource counter.
   * @member {number} [limit] The resource limit.
   * @member {object} [name] Quota name.
   * @member {string} [name.value] Non-localized name.
   * @member {string} [name.localizedValue] Localized name.
   */
  constructor() {
  }

  /**
   * Defines the metadata of CsmUsageQuota
   *
   * @returns {object} metadata of CsmUsageQuota
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CsmUsageQuota',
      type: {
        name: 'Composite',
        className: 'CsmUsageQuota',
        modelProperties: {
          unit: {
            required: false,
            serializedName: 'unit',
            type: {
              name: 'String'
            }
          },
          nextResetTime: {
            required: false,
            serializedName: 'nextResetTime',
            type: {
              name: 'DateTime'
            }
          },
          currentValue: {
            required: false,
            serializedName: 'currentValue',
            type: {
              name: 'Number'
            }
          },
          limit: {
            required: false,
            serializedName: 'limit',
            type: {
              name: 'Number'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'Composite',
              className: 'LocalizableString'
            }
          }
        }
      }
    };
  }
}

module.exports = CsmUsageQuota;
