/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing data source used by the detectors
 *
 */
class DataSource {
  /**
   * Create a DataSource.
   * @member {array} [instructions] Instrunctions if any for the data source
   * @member {array} [dataSourceUri] Datasource Uri Links
   */
  constructor() {
  }

  /**
   * Defines the metadata of DataSource
   *
   * @returns {object} metadata of DataSource
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DataSource',
      type: {
        name: 'Composite',
        className: 'DataSource',
        modelProperties: {
          instructions: {
            required: false,
            serializedName: 'instructions',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          dataSourceUri: {
            required: false,
            serializedName: 'dataSourceUri',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'NameValuePairElementType',
                  type: {
                    name: 'Composite',
                    className: 'NameValuePair'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = DataSource;
