/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * App Service error response.
 *
 */
class DefaultErrorResponse {
  /**
   * Create a DefaultErrorResponse.
   * @member {object} [error] Error model.
   * @member {string} [error.code] Standardized string to programmatically
   * identify the error.
   * @member {string} [error.message] Detailed error description and debugging
   * information.
   * @member {string} [error.target] Detailed error description and debugging
   * information.
   * @member {array} [error.details]
   * @member {string} [error.innererror] More information to debug error.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DefaultErrorResponse
   *
   * @returns {object} metadata of DefaultErrorResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DefaultErrorResponse',
      type: {
        name: 'Composite',
        className: 'DefaultErrorResponse',
        modelProperties: {
          error: {
            required: false,
            readOnly: true,
            serializedName: 'error',
            type: {
              name: 'Composite',
              className: 'DefaultErrorResponseError'
            }
          }
        }
      }
    };
  }
}

module.exports = DefaultErrorResponse;
