/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Error model.
 *
 */
class DefaultErrorResponseError {
  /**
   * Create a DefaultErrorResponseError.
   * @member {string} [code] Standardized string to programmatically identify
   * the error.
   * @member {string} [message] Detailed error description and debugging
   * information.
   * @member {string} [target] Detailed error description and debugging
   * information.
   * @member {array} [details]
   * @member {string} [innererror] More information to debug error.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DefaultErrorResponseError
   *
   * @returns {object} metadata of DefaultErrorResponseError
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DefaultErrorResponse_error',
      type: {
        name: 'Composite',
        className: 'DefaultErrorResponseError',
        modelProperties: {
          code: {
            required: false,
            readOnly: true,
            serializedName: 'code',
            type: {
              name: 'String'
            }
          },
          message: {
            required: false,
            readOnly: true,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          },
          target: {
            required: false,
            readOnly: true,
            serializedName: 'target',
            type: {
              name: 'String'
            }
          },
          details: {
            required: false,
            serializedName: 'details',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'DefaultErrorResponseErrorDetailsItemElementType',
                  type: {
                    name: 'Composite',
                    className: 'DefaultErrorResponseErrorDetailsItem'
                  }
              }
            }
          },
          innererror: {
            required: false,
            readOnly: true,
            serializedName: 'innererror',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DefaultErrorResponseError;
