/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Details about restoring a deleted app.
 *
 * @extends models['ProxyOnlyResource']
 */
class DeletedAppRestoreRequest extends models['ProxyOnlyResource'] {
  /**
   * Create a DeletedAppRestoreRequest.
   * @member {string} [deletedSiteId] ARM resource ID of the deleted app.
   * Example:
   * /subscriptions/{subId}/providers/Microsoft.Web/deletedSites/{deletedSiteId}
   * @member {boolean} [recoverConfiguration] If true, deleted site
   * configuration, in addition to content, will be restored.
   * @member {string} [snapshotTime] Point in time to restore the deleted app
   * from, formatted as a DateTime string.
   * If unspecified, default value is the time that the app was deleted.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of DeletedAppRestoreRequest
   *
   * @returns {object} metadata of DeletedAppRestoreRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DeletedAppRestoreRequest',
      type: {
        name: 'Composite',
        className: 'DeletedAppRestoreRequest',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: false,
            serializedName: 'kind',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          deletedSiteId: {
            required: false,
            serializedName: 'properties.deletedSiteId',
            type: {
              name: 'String'
            }
          },
          recoverConfiguration: {
            required: false,
            serializedName: 'properties.recoverConfiguration',
            type: {
              name: 'Boolean'
            }
          },
          snapshotTime: {
            required: false,
            serializedName: 'properties.snapshotTime',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DeletedAppRestoreRequest;
