/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * List of available locations (regions or App Service Environments) for
 * deployment of App Service resources.
 *
 */
class DeploymentLocations {
  /**
   * Create a DeploymentLocations.
   * @member {array} [locations] Available regions.
   * @member {array} [hostingEnvironments] Available App Service Environments
   * with full descriptions of the environments.
   * @member {array} [hostingEnvironmentDeploymentInfos] Available App Service
   * Environments with basic information.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DeploymentLocations
   *
   * @returns {object} metadata of DeploymentLocations
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DeploymentLocations',
      type: {
        name: 'Composite',
        className: 'DeploymentLocations',
        modelProperties: {
          locations: {
            required: false,
            serializedName: 'locations',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'GeoRegionElementType',
                  type: {
                    name: 'Composite',
                    className: 'GeoRegion'
                  }
              }
            }
          },
          hostingEnvironments: {
            required: false,
            serializedName: 'hostingEnvironments',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'AppServiceEnvironmentElementType',
                  type: {
                    name: 'Composite',
                    className: 'AppServiceEnvironment'
                  }
              }
            }
          },
          hostingEnvironmentDeploymentInfos: {
            required: false,
            serializedName: 'hostingEnvironmentDeploymentInfos',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'HostingEnvironmentDeploymentInfoElementType',
                  type: {
                    name: 'Composite',
                    className: 'HostingEnvironmentDeploymentInfo'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = DeploymentLocations;
