/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Class representing detector definition
 *
 * @extends models['ProxyOnlyResource']
 */
class DetectorDefinition extends models['ProxyOnlyResource'] {
  /**
   * Create a DetectorDefinition.
   * @member {string} [displayName] Display name of the detector
   * @member {string} [description] Description of the detector
   * @member {number} [rank] Detector Rank
   * @member {boolean} [isEnabled] Flag representing whether detector is
   * enabled or not.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of DetectorDefinition
   *
   * @returns {object} metadata of DetectorDefinition
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DetectorDefinition',
      type: {
        name: 'Composite',
        className: 'DetectorDefinition',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: false,
            serializedName: 'kind',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          displayName: {
            required: false,
            readOnly: true,
            serializedName: 'properties.displayName',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            readOnly: true,
            serializedName: 'properties.description',
            type: {
              name: 'String'
            }
          },
          rank: {
            required: false,
            readOnly: true,
            serializedName: 'properties.rank',
            type: {
              name: 'Number'
            }
          },
          isEnabled: {
            required: false,
            readOnly: true,
            serializedName: 'properties.isEnabled',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = DetectorDefinition;
