/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Definition of Detector
 *
 */
class DetectorInfo {
  /**
   * Create a DetectorInfo.
   * @member {string} [description] Short description of the detector and its
   * purpose
   * @member {string} [category] Support Category
   * @member {string} [subCategory] Support Sub Category
   * @member {string} [supportTopicId] Support Topic Id
   */
  constructor() {
  }

  /**
   * Defines the metadata of DetectorInfo
   *
   * @returns {object} metadata of DetectorInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DetectorInfo',
      type: {
        name: 'Composite',
        className: 'DetectorInfo',
        modelProperties: {
          description: {
            required: false,
            readOnly: true,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          category: {
            required: false,
            readOnly: true,
            serializedName: 'category',
            type: {
              name: 'String'
            }
          },
          subCategory: {
            required: false,
            readOnly: true,
            serializedName: 'subCategory',
            type: {
              name: 'String'
            }
          },
          supportTopicId: {
            required: false,
            readOnly: true,
            serializedName: 'supportTopicId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DetectorInfo;
