/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Class representing Response from Detector
 *
 * @extends models['ProxyOnlyResource']
 */
class DetectorResponse extends models['ProxyOnlyResource'] {
  /**
   * Create a DetectorResponse.
   * @member {object} [metadata] metadata for the detector
   * @member {string} [metadata.description] Short description of the detector
   * and its purpose
   * @member {string} [metadata.category] Support Category
   * @member {string} [metadata.subCategory] Support Sub Category
   * @member {string} [metadata.supportTopicId] Support Topic Id
   * @member {array} [dataset] Data Set
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of DetectorResponse
   *
   * @returns {object} metadata of DetectorResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DetectorResponse',
      type: {
        name: 'Composite',
        className: 'DetectorResponse',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: false,
            serializedName: 'kind',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          metadata: {
            required: false,
            serializedName: 'properties.metadata',
            type: {
              name: 'Composite',
              className: 'DetectorInfo'
            }
          },
          dataset: {
            required: false,
            serializedName: 'properties.dataset',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'DiagnosticDataElementType',
                  type: {
                    name: 'Composite',
                    className: 'DiagnosticData'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = DetectorResponse;
