/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Set of data with rendering instructions
 *
 */
class DiagnosticData {
  /**
   * Create a DiagnosticData.
   * @member {object} [table] Data in table form
   * @member {string} [table.tableName] Name of the table
   * @member {array} [table.columns] List of columns with data types
   * @member {array} [table.rows] Raw row values
   * @member {object} [renderingProperties] Properties that describe how the
   * table should be rendered
   * @member {string} [renderingProperties.type] Rendering Type. Possible
   * values include: 'NoGraph', 'Table', 'TimeSeries', 'TimeSeriesPerInstance'
   * @member {string} [renderingProperties.title] Title of data
   * @member {string} [renderingProperties.description] Description of the data
   * that will help it be interpreted
   */
  constructor() {
  }

  /**
   * Defines the metadata of DiagnosticData
   *
   * @returns {object} metadata of DiagnosticData
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DiagnosticData',
      type: {
        name: 'Composite',
        className: 'DiagnosticData',
        modelProperties: {
          table: {
            required: false,
            serializedName: 'table',
            type: {
              name: 'Composite',
              className: 'DataTableResponseObject'
            }
          },
          renderingProperties: {
            required: false,
            serializedName: 'renderingProperties',
            type: {
              name: 'Composite',
              className: 'Rendering'
            }
          }
        }
      }
    };
  }
}

module.exports = DiagnosticData;
