/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Dimension of a resource metric. For e.g. instance specific HTTP requests for
 * a web app,
 * where instance name is dimension of the metric HTTP request
 *
 */
class Dimension {
  /**
   * Create a Dimension.
   * @member {string} [name]
   * @member {string} [displayName]
   * @member {string} [internalName]
   * @member {boolean} [toBeExportedForShoebox]
   */
  constructor() {
  }

  /**
   * Defines the metadata of Dimension
   *
   * @returns {object} metadata of Dimension
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Dimension',
      type: {
        name: 'Composite',
        className: 'Dimension',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          displayName: {
            required: false,
            serializedName: 'displayName',
            type: {
              name: 'String'
            }
          },
          internalName: {
            required: false,
            serializedName: 'internalName',
            type: {
              name: 'String'
            }
          },
          toBeExportedForShoebox: {
            required: false,
            serializedName: 'toBeExportedForShoebox',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = Dimension;
