/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Single sign-on request information for domain management.
 *
 */
class DomainControlCenterSsoRequest {
  /**
   * Create a DomainControlCenterSsoRequest.
   * @member {string} [url] URL where the single sign-on request is to be made.
   * @member {string} [postParameterKey] Post parameter key.
   * @member {string} [postParameterValue] Post parameter value. Client should
   * use 'application/x-www-form-urlencoded' encoding for this value.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DomainControlCenterSsoRequest
   *
   * @returns {object} metadata of DomainControlCenterSsoRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DomainControlCenterSsoRequest',
      type: {
        name: 'Composite',
        className: 'DomainControlCenterSsoRequest',
        modelProperties: {
          url: {
            required: false,
            readOnly: true,
            serializedName: 'url',
            type: {
              name: 'String'
            }
          },
          postParameterKey: {
            required: false,
            readOnly: true,
            serializedName: 'postParameterKey',
            type: {
              name: 'String'
            }
          },
          postParameterValue: {
            required: false,
            readOnly: true,
            serializedName: 'postParameterValue',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DomainControlCenterSsoRequest;
