/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Function secrets.
 *
 * @extends models['ProxyOnlyResource']
 */
class FunctionSecrets extends models['ProxyOnlyResource'] {
  /**
   * Create a FunctionSecrets.
   * @member {string} [key] Secret key.
   * @member {string} [triggerUrl] Trigger URL.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of FunctionSecrets
   *
   * @returns {object} metadata of FunctionSecrets
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'FunctionSecrets',
      type: {
        name: 'Composite',
        className: 'FunctionSecrets',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: false,
            serializedName: 'kind',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          key: {
            required: false,
            serializedName: 'properties.key',
            type: {
              name: 'String'
            }
          },
          triggerUrl: {
            required: false,
            serializedName: 'properties.trigger_url',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = FunctionSecrets;
