/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The IIS handler mappings used to define which handler processes HTTP
 * requests with certain extension.
 * For example, it is used to configure php-cgi.exe process to handle all HTTP
 * requests with *.php extension.
 *
 */
class HandlerMapping {
  /**
   * Create a HandlerMapping.
   * @member {string} [extension] Requests with this extension will be handled
   * using the specified FastCGI application.
   * @member {string} [scriptProcessor] The absolute path to the FastCGI
   * application.
   * @member {string} [argumentsProperty] Command-line arguments to be passed
   * to the script processor.
   */
  constructor() {
  }

  /**
   * Defines the metadata of HandlerMapping
   *
   * @returns {object} metadata of HandlerMapping
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'HandlerMapping',
      type: {
        name: 'Composite',
        className: 'HandlerMapping',
        modelProperties: {
          extension: {
            required: false,
            serializedName: 'extension',
            type: {
              name: 'String'
            }
          },
          scriptProcessor: {
            required: false,
            serializedName: 'scriptProcessor',
            type: {
              name: 'String'
            }
          },
          argumentsProperty: {
            required: false,
            serializedName: 'arguments',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = HandlerMapping;
