/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Specification for an App Service Environment to use for this resource.
 *
 */
class HostingEnvironmentProfile {
  /**
   * Create a HostingEnvironmentProfile.
   * @member {string} [id] Resource ID of the App Service Environment.
   * @member {string} [name] Name of the App Service Environment.
   * @member {string} [type] Resource type of the App Service Environment.
   */
  constructor() {
  }

  /**
   * Defines the metadata of HostingEnvironmentProfile
   *
   * @returns {object} metadata of HostingEnvironmentProfile
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'HostingEnvironmentProfile',
      type: {
        name: 'Composite',
        className: 'HostingEnvironmentProfile',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = HostingEnvironmentProfile;
