/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Hybrid Connection key contract. This has the send key name and value for a
 * Hybrid Connection.
 *
 * @extends models['ProxyOnlyResource']
 */
class HybridConnectionKey extends models['ProxyOnlyResource'] {
  /**
   * Create a HybridConnectionKey.
   * @member {string} [sendKeyName] The name of the send key.
   * @member {string} [sendKeyValue] The value of the send key.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of HybridConnectionKey
   *
   * @returns {object} metadata of HybridConnectionKey
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'HybridConnectionKey',
      type: {
        name: 'Composite',
        className: 'HybridConnectionKey',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: false,
            serializedName: 'kind',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          sendKeyName: {
            required: false,
            readOnly: true,
            serializedName: 'properties.sendKeyName',
            type: {
              name: 'String'
            }
          },
          sendKeyValue: {
            required: false,
            readOnly: true,
            serializedName: 'properties.sendKeyValue',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = HybridConnectionKey;
