/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Hybrid Connection limits contract. This is used to return the plan limits of
 * Hybrid Connections.
 *
 * @extends models['ProxyOnlyResource']
 */
class HybridConnectionLimits extends models['ProxyOnlyResource'] {
  /**
   * Create a HybridConnectionLimits.
   * @member {number} [current] The current number of Hybrid Connections.
   * @member {number} [maximum] The maximum number of Hybrid Connections
   * allowed.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of HybridConnectionLimits
   *
   * @returns {object} metadata of HybridConnectionLimits
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'HybridConnectionLimits',
      type: {
        name: 'Composite',
        className: 'HybridConnectionLimits',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: false,
            serializedName: 'kind',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          current: {
            required: false,
            readOnly: true,
            serializedName: 'properties.current',
            type: {
              name: 'Number'
            }
          },
          maximum: {
            required: false,
            readOnly: true,
            serializedName: 'properties.maximum',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = HybridConnectionLimits;
