/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A domain specific resource identifier.
 *
 * @extends models['ProxyOnlyResource']
 */
class Identifier extends models['ProxyOnlyResource'] {
  /**
   * Create a Identifier.
   * @member {string} [identifierId] String representation of the identity.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of Identifier
   *
   * @returns {object} metadata of Identifier
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Identifier',
      type: {
        name: 'Composite',
        className: 'Identifier',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: false,
            serializedName: 'kind',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          identifierId: {
            required: false,
            serializedName: 'properties.id',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = Identifier;
