/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * MSDeploy log
 *
 * @extends models['ProxyOnlyResource']
 */
class MSDeployLog extends models['ProxyOnlyResource'] {
  /**
   * Create a MSDeployLog.
   * @member {array} [entries] List of log entry messages
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of MSDeployLog
   *
   * @returns {object} metadata of MSDeployLog
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'MSDeployLog',
      type: {
        name: 'Composite',
        className: 'MSDeployLog',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: false,
            serializedName: 'kind',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          entries: {
            required: false,
            readOnly: true,
            serializedName: 'properties.entries',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'MSDeployLogEntryElementType',
                  type: {
                    name: 'Composite',
                    className: 'MSDeployLogEntry'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = MSDeployLog;
