/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * MSDeploy log entry
 *
 */
class MSDeployLogEntry {
  /**
   * Create a MSDeployLogEntry.
   * @member {date} [time] Timestamp of log entry
   * @member {string} [type] Log entry type. Possible values include:
   * 'Message', 'Warning', 'Error'
   * @member {string} [message] Log entry message
   */
  constructor() {
  }

  /**
   * Defines the metadata of MSDeployLogEntry
   *
   * @returns {object} metadata of MSDeployLogEntry
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'MSDeployLogEntry',
      type: {
        name: 'Composite',
        className: 'MSDeployLogEntry',
        modelProperties: {
          time: {
            required: false,
            readOnly: true,
            serializedName: 'time',
            type: {
              name: 'DateTime'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'Enum',
              allowedValues: [ 'Message', 'Warning', 'Error' ]
            }
          },
          message: {
            required: false,
            readOnly: true,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = MSDeployLogEntry;
