/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * MSDeploy ARM response
 *
 * @extends models['ProxyOnlyResource']
 */
class MSDeployStatus extends models['ProxyOnlyResource'] {
  /**
   * Create a MSDeployStatus.
   * @member {string} [deployer] Username of deployer
   * @member {string} [provisioningState] Provisioning state. Possible values
   * include: 'accepted', 'running', 'succeeded', 'failed', 'canceled'
   * @member {date} [startTime] Start time of deploy operation
   * @member {date} [endTime] End time of deploy operation
   * @member {boolean} [complete] Whether the deployment operation has
   * completed
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of MSDeployStatus
   *
   * @returns {object} metadata of MSDeployStatus
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'MSDeployStatus',
      type: {
        name: 'Composite',
        className: 'MSDeployStatus',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: false,
            serializedName: 'kind',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          deployer: {
            required: false,
            readOnly: true,
            serializedName: 'properties.deployer',
            type: {
              name: 'String'
            }
          },
          provisioningState: {
            required: false,
            readOnly: true,
            serializedName: 'properties.provisioningState',
            type: {
              name: 'Enum',
              allowedValues: [ 'accepted', 'running', 'succeeded', 'failed', 'canceled' ]
            }
          },
          startTime: {
            required: false,
            readOnly: true,
            serializedName: 'properties.startTime',
            type: {
              name: 'DateTime'
            }
          },
          endTime: {
            required: false,
            readOnly: true,
            serializedName: 'properties.endTime',
            type: {
              name: 'DateTime'
            }
          },
          complete: {
            required: false,
            readOnly: true,
            serializedName: 'properties.complete',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = MSDeployStatus;
