/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * MySQL migration request.
 *
 * @extends models['ProxyOnlyResource']
 */
class MigrateMySqlRequest extends models['ProxyOnlyResource'] {
  /**
   * Create a MigrateMySqlRequest.
   * @member {string} connectionString Connection string to the remote MySQL
   * database.
   * @member {string} migrationType The type of migration operation to be done.
   * Possible values include: 'LocalToRemote', 'RemoteToLocal'
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of MigrateMySqlRequest
   *
   * @returns {object} metadata of MigrateMySqlRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'MigrateMySqlRequest',
      type: {
        name: 'Composite',
        className: 'MigrateMySqlRequest',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: false,
            serializedName: 'kind',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          connectionString: {
            required: true,
            serializedName: 'properties.connectionString',
            type: {
              name: 'String'
            }
          },
          migrationType: {
            required: true,
            serializedName: 'properties.migrationType',
            type: {
              name: 'Enum',
              allowedValues: [ 'LocalToRemote', 'RemoteToLocal' ]
            }
          }
        }
      }
    };
  }
}

module.exports = MigrateMySqlRequest;
