/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * MySQL migration status.
 *
 * @extends models['ProxyOnlyResource']
 */
class MigrateMySqlStatus extends models['ProxyOnlyResource'] {
  /**
   * Create a MigrateMySqlStatus.
   * @member {string} [migrationOperationStatus] Status of the migration task.
   * Possible values include: 'InProgress', 'Failed', 'Succeeded', 'TimedOut',
   * 'Created'
   * @member {string} [operationId] Operation ID for the migration task.
   * @member {boolean} [localMySqlEnabled] True if the web app has in app MySql
   * enabled
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of MigrateMySqlStatus
   *
   * @returns {object} metadata of MigrateMySqlStatus
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'MigrateMySqlStatus',
      type: {
        name: 'Composite',
        className: 'MigrateMySqlStatus',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: false,
            serializedName: 'kind',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          migrationOperationStatus: {
            required: false,
            readOnly: true,
            serializedName: 'properties.migrationOperationStatus',
            type: {
              name: 'Enum',
              allowedValues: [ 'InProgress', 'Failed', 'Succeeded', 'TimedOut', 'Created' ]
            }
          },
          operationId: {
            required: false,
            readOnly: true,
            serializedName: 'properties.operationId',
            type: {
              name: 'String'
            }
          },
          localMySqlEnabled: {
            required: false,
            readOnly: true,
            serializedName: 'properties.localMySqlEnabled',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = MigrateMySqlStatus;
