/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Network access control entry.
 *
 */
class NetworkAccessControlEntry {
  /**
   * Create a NetworkAccessControlEntry.
   * @member {string} [action] Action object. Possible values include:
   * 'Permit', 'Deny'
   * @member {string} [description] Description of network access control
   * entry.
   * @member {number} [order] Order of precedence.
   * @member {string} [remoteSubnet] Remote subnet.
   */
  constructor() {
  }

  /**
   * Defines the metadata of NetworkAccessControlEntry
   *
   * @returns {object} metadata of NetworkAccessControlEntry
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'NetworkAccessControlEntry',
      type: {
        name: 'Composite',
        className: 'NetworkAccessControlEntry',
        modelProperties: {
          action: {
            required: false,
            serializedName: 'action',
            type: {
              name: 'Enum',
              allowedValues: [ 'Permit', 'Deny' ]
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          order: {
            required: false,
            serializedName: 'order',
            type: {
              name: 'Number'
            }
          },
          remoteSubnet: {
            required: false,
            serializedName: 'remoteSubnet',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = NetworkAccessControlEntry;
