/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Performance monitor sample in a set.
 *
 */
class PerfMonSample {
  /**
   * Create a PerfMonSample.
   * @member {date} [time] Point in time for which counter was measured.
   * @member {string} [instanceName] Name of the server on which the
   * measurement is made.
   * @member {number} [value] Value of counter at a certain time.
   */
  constructor() {
  }

  /**
   * Defines the metadata of PerfMonSample
   *
   * @returns {object} metadata of PerfMonSample
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PerfMonSample',
      type: {
        name: 'Composite',
        className: 'PerfMonSample',
        modelProperties: {
          time: {
            required: false,
            serializedName: 'time',
            type: {
              name: 'DateTime'
            }
          },
          instanceName: {
            required: false,
            serializedName: 'instanceName',
            type: {
              name: 'String'
            }
          },
          value: {
            required: false,
            serializedName: 'value',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = PerfMonSample;
