/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Metric information.
 *
 */
class PerfMonSet {
  /**
   * Create a PerfMonSet.
   * @member {string} [name] Unique key name of the counter.
   * @member {date} [startTime] Start time of the period.
   * @member {date} [endTime] End time of the period.
   * @member {string} [timeGrain] Presented time grain.
   * @member {array} [values] Collection of workers that are active during this
   * time.
   */
  constructor() {
  }

  /**
   * Defines the metadata of PerfMonSet
   *
   * @returns {object} metadata of PerfMonSet
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PerfMonSet',
      type: {
        name: 'Composite',
        className: 'PerfMonSet',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          startTime: {
            required: false,
            serializedName: 'startTime',
            type: {
              name: 'DateTime'
            }
          },
          endTime: {
            required: false,
            serializedName: 'endTime',
            type: {
              name: 'DateTime'
            }
          },
          timeGrain: {
            required: false,
            serializedName: 'timeGrain',
            type: {
              name: 'String'
            }
          },
          values: {
            required: false,
            serializedName: 'values',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'PerfMonSampleElementType',
                  type: {
                    name: 'Composite',
                    className: 'PerfMonSample'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = PerfMonSet;
