/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Description of the parameters of Private Access for a Web Site.
 *
 * @extends models['ProxyOnlyResource']
 */
class PrivateAccess extends models['ProxyOnlyResource'] {
  /**
   * Create a PrivateAccess.
   * @member {boolean} [enabled] Whether private access is enabled or not.
   * @member {array} [virtualNetworks] The Virtual Networks (and subnets)
   * allowed to access the site privately.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of PrivateAccess
   *
   * @returns {object} metadata of PrivateAccess
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PrivateAccess',
      type: {
        name: 'Composite',
        className: 'PrivateAccess',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: false,
            serializedName: 'kind',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          enabled: {
            required: false,
            serializedName: 'properties.enabled',
            type: {
              name: 'Boolean'
            }
          },
          virtualNetworks: {
            required: false,
            serializedName: 'properties.virtualNetworks',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'PrivateAccessVirtualNetworkElementType',
                  type: {
                    name: 'Composite',
                    className: 'PrivateAccessVirtualNetwork'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = PrivateAccess;
