/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Description of a Virtual Network subnet that is useable for private site
 * access.
 *
 */
class PrivateAccessSubnet {
  /**
   * Create a PrivateAccessSubnet.
   * @member {string} [name] The name of the subnet.
   * @member {number} [key] The key (ID) of the subnet.
   */
  constructor() {
  }

  /**
   * Defines the metadata of PrivateAccessSubnet
   *
   * @returns {object} metadata of PrivateAccessSubnet
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PrivateAccessSubnet',
      type: {
        name: 'Composite',
        className: 'PrivateAccessSubnet',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          key: {
            required: false,
            serializedName: 'key',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = PrivateAccessSubnet;
