/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Public certificate object
 *
 * @extends models['ProxyOnlyResource']
 */
class PublicCertificate extends models['ProxyOnlyResource'] {
  /**
   * Create a PublicCertificate.
   * @member {buffer} [blob] Public Certificate byte array
   * @member {string} [publicCertificateLocation] Public Certificate Location.
   * Possible values include: 'CurrentUserMy', 'LocalMachineMy', 'Unknown'
   * @member {string} [thumbprint] Certificate Thumbprint
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of PublicCertificate
   *
   * @returns {object} metadata of PublicCertificate
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PublicCertificate',
      type: {
        name: 'Composite',
        className: 'PublicCertificate',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: false,
            serializedName: 'kind',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          blob: {
            required: false,
            serializedName: 'properties.blob',
            type: {
              name: 'ByteArray'
            }
          },
          publicCertificateLocation: {
            required: false,
            serializedName: 'properties.publicCertificateLocation',
            type: {
              name: 'Enum',
              allowedValues: [ 'CurrentUserMy', 'LocalMachineMy', 'Unknown' ]
            }
          },
          thumbprint: {
            required: false,
            readOnly: true,
            serializedName: 'properties.thumbprint',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = PublicCertificate;
