/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Instructions for rendering the data
 *
 */
class Rendering {
  /**
   * Create a Rendering.
   * @member {string} [type] Rendering Type. Possible values include:
   * 'NoGraph', 'Table', 'TimeSeries', 'TimeSeriesPerInstance'
   * @member {string} [title] Title of data
   * @member {string} [description] Description of the data that will help it
   * be interpreted
   */
  constructor() {
  }

  /**
   * Defines the metadata of Rendering
   *
   * @returns {object} metadata of Rendering
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Rendering',
      type: {
        name: 'Composite',
        className: 'Rendering',
        modelProperties: {
          type: {
            required: false,
            serializedName: 'type',
            type: {
              name: 'Enum',
              allowedValues: [ 'NoGraph', 'Table', 'TimeSeries', 'TimeSeriesPerInstance' ]
            }
          },
          title: {
            required: false,
            serializedName: 'title',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = Rendering;
