/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Class representing certificate renew request.
 *
 * @extends models['ProxyOnlyResource']
 */
class RenewCertificateOrderRequest extends models['ProxyOnlyResource'] {
  /**
   * Create a RenewCertificateOrderRequest.
   * @member {number} [keySize] Certificate Key Size.
   * @member {string} [csr] Csr to be used for re-key operation.
   * @member {boolean} [isPrivateKeyExternal] Should we change the ASC type
   * (from managed private key to external private key and vice versa).
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of RenewCertificateOrderRequest
   *
   * @returns {object} metadata of RenewCertificateOrderRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RenewCertificateOrderRequest',
      type: {
        name: 'Composite',
        className: 'RenewCertificateOrderRequest',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: false,
            serializedName: 'kind',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          keySize: {
            required: false,
            serializedName: 'properties.keySize',
            type: {
              name: 'Number'
            }
          },
          csr: {
            required: false,
            serializedName: 'properties.csr',
            type: {
              name: 'String'
            }
          },
          isPrivateKeyExternal: {
            required: false,
            serializedName: 'properties.isPrivateKeyExternal',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = RenewCertificateOrderRequest;
