/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Used for getting ResourceHealthCheck settings.
 *
 * @extends models['ProxyOnlyResource']
 */
class ResourceHealthMetadata extends models['ProxyOnlyResource'] {
  /**
   * Create a ResourceHealthMetadata.
   * @member {string} [category] The category that the resource matches in the
   * RHC Policy File
   * @member {boolean} [signalAvailability] Is there a health signal for the
   * resource
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ResourceHealthMetadata
   *
   * @returns {object} metadata of ResourceHealthMetadata
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ResourceHealthMetadata',
      type: {
        name: 'Composite',
        className: 'ResourceHealthMetadata',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: false,
            serializedName: 'kind',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          category: {
            required: false,
            serializedName: 'properties.category',
            type: {
              name: 'String'
            }
          },
          signalAvailability: {
            required: false,
            serializedName: 'properties.signalAvailability',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = ResourceHealthMetadata;
