/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Metadata for the metrics.
 *
 * @extends models['ProxyOnlyResource']
 */
class ResourceMetricDefinition extends models['ProxyOnlyResource'] {
  /**
   * Create a ResourceMetricDefinition.
   * @member {string} [unit] Unit of the metric.
   * @member {string} [primaryAggregationType] Primary aggregation type.
   * @member {array} [metricAvailabilities] List of time grains supported for
   * the metric together with retention period.
   * @member {string} [resourceUri] Resource URI.
   * @member {object} [properties] Resource metric definition properties.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ResourceMetricDefinition
   *
   * @returns {object} metadata of ResourceMetricDefinition
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ResourceMetricDefinition',
      type: {
        name: 'Composite',
        className: 'ResourceMetricDefinition',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: false,
            serializedName: 'kind',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          unit: {
            required: false,
            readOnly: true,
            serializedName: 'properties.unit',
            type: {
              name: 'String'
            }
          },
          primaryAggregationType: {
            required: false,
            readOnly: true,
            serializedName: 'properties.primaryAggregationType',
            type: {
              name: 'String'
            }
          },
          metricAvailabilities: {
            required: false,
            readOnly: true,
            serializedName: 'properties.metricAvailabilities',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ResourceMetricAvailabilityElementType',
                  type: {
                    name: 'Composite',
                    className: 'ResourceMetricAvailability'
                  }
              }
            }
          },
          resourceUri: {
            required: false,
            readOnly: true,
            serializedName: 'properties.resourceUri',
            type: {
              name: 'String'
            }
          },
          properties: {
            required: false,
            readOnly: true,
            serializedName: 'properties.properties',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ResourceMetricDefinition;
