/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Resource name availability request content.
 *
 */
class ResourceNameAvailabilityRequest {
  /**
   * Create a ResourceNameAvailabilityRequest.
   * @member {string} name Resource name to verify.
   * @member {string} type Resource type used for verification. Possible values
   * include: 'Site', 'Slot', 'HostingEnvironment', 'PublishingUser',
   * 'Microsoft.Web/sites', 'Microsoft.Web/sites/slots',
   * 'Microsoft.Web/hostingEnvironments', 'Microsoft.Web/publishingUsers'
   * @member {boolean} [isFqdn] Is fully qualified domain name.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ResourceNameAvailabilityRequest
   *
   * @returns {object} metadata of ResourceNameAvailabilityRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ResourceNameAvailabilityRequest',
      type: {
        name: 'Composite',
        className: 'ResourceNameAvailabilityRequest',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          isFqdn: {
            required: false,
            serializedName: 'isFqdn',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = ResourceNameAvailabilityRequest;
