/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Instance of an app.
 *
 * @extends models['ProxyOnlyResource']
 */
class SiteInstance extends models['ProxyOnlyResource'] {
  /**
   * Create a SiteInstance.
   * @member {string} [siteInstanceName] Name of instance.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of SiteInstance
   *
   * @returns {object} metadata of SiteInstance
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SiteInstance',
      type: {
        name: 'Composite',
        className: 'SiteInstance',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: false,
            serializedName: 'kind',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          siteInstanceName: {
            required: false,
            readOnly: true,
            serializedName: 'properties.siteInstanceName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SiteInstance;
