/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Metric limits set on an app.
 *
 */
class SiteLimits {
  /**
   * Create a SiteLimits.
   * @member {number} [maxPercentageCpu] Maximum allowed CPU usage percentage.
   * @member {number} [maxMemoryInMb] Maximum allowed memory usage in MB.
   * @member {number} [maxDiskSizeInMb] Maximum allowed disk size usage in MB.
   */
  constructor() {
  }

  /**
   * Defines the metadata of SiteLimits
   *
   * @returns {object} metadata of SiteLimits
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SiteLimits',
      type: {
        name: 'Composite',
        className: 'SiteLimits',
        modelProperties: {
          maxPercentageCpu: {
            required: false,
            serializedName: 'maxPercentageCpu',
            type: {
              name: 'Number'
            }
          },
          maxMemoryInMb: {
            required: false,
            serializedName: 'maxMemoryInMb',
            type: {
              name: 'Number'
            }
          },
          maxDiskSizeInMb: {
            required: false,
            serializedName: 'maxDiskSizeInMb',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = SiteLimits;
