/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Site seal request.
 *
 */
class SiteSealRequest {
  /**
   * Create a SiteSealRequest.
   * @member {boolean} [lightTheme] If <code>true</code> use the light color
   * theme for site seal; otherwise, use the default color theme.
   * @member {string} [locale] Locale of site seal.
   */
  constructor() {
  }

  /**
   * Defines the metadata of SiteSealRequest
   *
   * @returns {object} metadata of SiteSealRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SiteSealRequest',
      type: {
        name: 'Composite',
        className: 'SiteSealRequest',
        modelProperties: {
          lightTheme: {
            required: false,
            serializedName: 'lightTheme',
            type: {
              name: 'Boolean'
            }
          },
          locale: {
            required: false,
            serializedName: 'locale',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SiteSealRequest;
