/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Description of the App Service plan scale options.
 *
 */
class SkuCapacity {
  /**
   * Create a SkuCapacity.
   * @member {number} [minimum] Minimum number of workers for this App Service
   * plan SKU.
   * @member {number} [maximum] Maximum number of workers for this App Service
   * plan SKU.
   * @member {number} [default] Default number of workers for this App Service
   * plan SKU.
   * @member {string} [scaleType] Available scale configurations for an App
   * Service plan.
   */
  constructor() {
  }

  /**
   * Defines the metadata of SkuCapacity
   *
   * @returns {object} metadata of SkuCapacity
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SkuCapacity',
      type: {
        name: 'Composite',
        className: 'SkuCapacity',
        modelProperties: {
          minimum: {
            required: false,
            serializedName: 'minimum',
            type: {
              name: 'Number'
            }
          },
          maximum: {
            required: false,
            serializedName: 'maximum',
            type: {
              name: 'Number'
            }
          },
          default: {
            required: false,
            serializedName: 'default',
            type: {
              name: 'Number'
            }
          },
          scaleType: {
            required: false,
            serializedName: 'scaleType',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SkuCapacity;
