/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * SKU discovery information.
 *
 */
class SkuInfo {
  /**
   * Create a SkuInfo.
   * @member {string} [resourceType] Resource type that this SKU applies to.
   * @member {object} [sku] Name and tier of the SKU.
   * @member {string} [sku.name] Name of the resource SKU.
   * @member {string} [sku.tier] Service tier of the resource SKU.
   * @member {string} [sku.size] Size specifier of the resource SKU.
   * @member {string} [sku.family] Family code of the resource SKU.
   * @member {number} [sku.capacity] Current number of instances assigned to
   * the resource.
   * @member {object} [sku.skuCapacity] Min, max, and default scale values of
   * the SKU.
   * @member {number} [sku.skuCapacity.minimum] Minimum number of workers for
   * this App Service plan SKU.
   * @member {number} [sku.skuCapacity.maximum] Maximum number of workers for
   * this App Service plan SKU.
   * @member {number} [sku.skuCapacity.default] Default number of workers for
   * this App Service plan SKU.
   * @member {string} [sku.skuCapacity.scaleType] Available scale
   * configurations for an App Service plan.
   * @member {array} [sku.locations] Locations of the SKU.
   * @member {array} [sku.capabilities] Capabilities of the SKU, e.g., is
   * traffic manager enabled?
   * @member {object} [capacity] Min, max, and default scale values of the SKU.
   * @member {number} [capacity.minimum] Minimum number of workers for this App
   * Service plan SKU.
   * @member {number} [capacity.maximum] Maximum number of workers for this App
   * Service plan SKU.
   * @member {number} [capacity.default] Default number of workers for this App
   * Service plan SKU.
   * @member {string} [capacity.scaleType] Available scale configurations for
   * an App Service plan.
   */
  constructor() {
  }

  /**
   * Defines the metadata of SkuInfo
   *
   * @returns {object} metadata of SkuInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SkuInfo',
      type: {
        name: 'Composite',
        className: 'SkuInfo',
        modelProperties: {
          resourceType: {
            required: false,
            serializedName: 'resourceType',
            type: {
              name: 'String'
            }
          },
          sku: {
            required: false,
            serializedName: 'sku',
            type: {
              name: 'Composite',
              className: 'SkuDescription'
            }
          },
          capacity: {
            required: false,
            serializedName: 'capacity',
            type: {
              name: 'Composite',
              className: 'SkuCapacity'
            }
          }
        }
      }
    };
  }
}

module.exports = SkuInfo;
