/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Collection of SKU information.
 *
 */
class SkuInfos {
  /**
   * Create a SkuInfos.
   * @member {string} [resourceType] Resource type that this SKU applies to.
   * @member {array} [skus] List of SKUs the subscription is able to use.
   */
  constructor() {
  }

  /**
   * Defines the metadata of SkuInfos
   *
   * @returns {object} metadata of SkuInfos
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SkuInfos',
      type: {
        name: 'Composite',
        className: 'SkuInfos',
        modelProperties: {
          resourceType: {
            required: false,
            serializedName: 'resourceType',
            type: {
              name: 'String'
            }
          },
          skus: {
            required: false,
            serializedName: 'skus',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'GlobalCsmSkuDescriptionElementType',
                  type: {
                    name: 'Composite',
                    className: 'GlobalCsmSkuDescription'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = SkuInfos;
