/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The status of the last successfull slot swap operation.
 *
 */
class SlotSwapStatus {
  /**
   * Create a SlotSwapStatus.
   * @member {date} [timestampUtc] The time the last successful slot swap
   * completed.
   * @member {string} [sourceSlotName] The source slot of the last swap
   * operation.
   * @member {string} [destinationSlotName] The destination slot of the last
   * swap operation.
   */
  constructor() {
  }

  /**
   * Defines the metadata of SlotSwapStatus
   *
   * @returns {object} metadata of SlotSwapStatus
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SlotSwapStatus',
      type: {
        name: 'Composite',
        className: 'SlotSwapStatus',
        modelProperties: {
          timestampUtc: {
            required: false,
            readOnly: true,
            serializedName: 'timestampUtc',
            type: {
              name: 'DateTime'
            }
          },
          sourceSlotName: {
            required: false,
            readOnly: true,
            serializedName: 'sourceSlotName',
            type: {
              name: 'String'
            }
          },
          destinationSlotName: {
            required: false,
            readOnly: true,
            serializedName: 'destinationSlotName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SlotSwapStatus;
