/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A snapshot of an app.
 *
 * @extends models['ProxyOnlyResource']
 */
class Snapshot extends models['ProxyOnlyResource'] {
  /**
   * Create a Snapshot.
   * @member {string} [time] The time the snapshot was taken.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of Snapshot
   *
   * @returns {object} metadata of Snapshot
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Snapshot',
      type: {
        name: 'Composite',
        className: 'Snapshot',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: false,
            serializedName: 'kind',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          time: {
            required: false,
            readOnly: true,
            serializedName: 'properties.time',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = Snapshot;
