/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The source control OAuth token.
 *
 * @extends models['ProxyOnlyResource']
 */
class SourceControl extends models['ProxyOnlyResource'] {
  /**
   * Create a SourceControl.
   * @member {string} [token] OAuth access token.
   * @member {string} [tokenSecret] OAuth access token secret.
   * @member {string} [refreshToken] OAuth refresh token.
   * @member {date} [expirationTime] OAuth token expiration.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of SourceControl
   *
   * @returns {object} metadata of SourceControl
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SourceControl',
      type: {
        name: 'Composite',
        className: 'SourceControl',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: false,
            serializedName: 'kind',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          token: {
            required: false,
            serializedName: 'properties.token',
            type: {
              name: 'String'
            }
          },
          tokenSecret: {
            required: false,
            serializedName: 'properties.tokenSecret',
            type: {
              name: 'String'
            }
          },
          refreshToken: {
            required: false,
            serializedName: 'properties.refreshToken',
            type: {
              name: 'String'
            }
          },
          expirationTime: {
            required: false,
            serializedName: 'properties.expirationTime',
            type: {
              name: 'DateTime'
            }
          }
        }
      }
    };
  }
}

module.exports = SourceControl;
