/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Application stack minor version.
 *
 */
class StackMinorVersion {
  /**
   * Create a StackMinorVersion.
   * @member {string} [displayVersion] Application stack minor version (display
   * only).
   * @member {string} [runtimeVersion] Application stack minor version (runtime
   * only).
   * @member {boolean} [isDefault] <code>true</code> if this is the default
   * minor version; otherwise, <code>false</code>.
   */
  constructor() {
  }

  /**
   * Defines the metadata of StackMinorVersion
   *
   * @returns {object} metadata of StackMinorVersion
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'StackMinorVersion',
      type: {
        name: 'Composite',
        className: 'StackMinorVersion',
        modelProperties: {
          displayVersion: {
            required: false,
            serializedName: 'displayVersion',
            type: {
              name: 'String'
            }
          },
          runtimeVersion: {
            required: false,
            serializedName: 'runtimeVersion',
            type: {
              name: 'String'
            }
          },
          isDefault: {
            required: false,
            serializedName: 'isDefault',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = StackMinorVersion;
