/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Options for app content migration.
 *
 * @extends models['ProxyOnlyResource']
 */
class StorageMigrationOptions extends models['ProxyOnlyResource'] {
  /**
   * Create a StorageMigrationOptions.
   * @member {string} azurefilesConnectionString AzureFiles connection string.
   * @member {string} azurefilesShare AzureFiles share.
   * @member {boolean} [switchSiteAfterMigration] <code>true</code>if the app
   * should be switched over; otherwise, <code>false</code>. Default value:
   * false .
   * @member {boolean} [blockWriteAccessToSite] <code>true</code> if the app
   * should be read only during copy operation; otherwise, <code>false</code>.
   * Default value: false .
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of StorageMigrationOptions
   *
   * @returns {object} metadata of StorageMigrationOptions
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'StorageMigrationOptions',
      type: {
        name: 'Composite',
        className: 'StorageMigrationOptions',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: false,
            serializedName: 'kind',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          azurefilesConnectionString: {
            required: true,
            serializedName: 'properties.azurefilesConnectionString',
            type: {
              name: 'String'
            }
          },
          azurefilesShare: {
            required: true,
            serializedName: 'properties.azurefilesShare',
            type: {
              name: 'String'
            }
          },
          switchSiteAfterMigration: {
            required: false,
            serializedName: 'properties.switchSiteAfterMigration',
            defaultValue: false,
            type: {
              name: 'Boolean'
            }
          },
          blockWriteAccessToSite: {
            required: false,
            serializedName: 'properties.blockWriteAccessToSite',
            defaultValue: false,
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = StorageMigrationOptions;
