/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Legal agreement for a top level domain.
 *
 */
class TldLegalAgreement {
  /**
   * Create a TldLegalAgreement.
   * @member {string} agreementKey Unique identifier for the agreement.
   * @member {string} title Agreement title.
   * @member {string} content Agreement details.
   * @member {string} [url] URL where a copy of the agreement details is
   * hosted.
   */
  constructor() {
  }

  /**
   * Defines the metadata of TldLegalAgreement
   *
   * @returns {object} metadata of TldLegalAgreement
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TldLegalAgreement',
      type: {
        name: 'Composite',
        className: 'TldLegalAgreement',
        modelProperties: {
          agreementKey: {
            required: true,
            serializedName: 'agreementKey',
            type: {
              name: 'String'
            }
          },
          title: {
            required: true,
            serializedName: 'title',
            type: {
              name: 'String'
            }
          },
          content: {
            required: true,
            serializedName: 'content',
            type: {
              name: 'String'
            }
          },
          url: {
            required: false,
            serializedName: 'url',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = TldLegalAgreement;
