/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A top level domain object.
 *
 * @extends models['ProxyOnlyResource']
 */
class TopLevelDomain extends models['ProxyOnlyResource'] {
  /**
   * Create a TopLevelDomain.
   * @member {boolean} [privacy] If <code>true</code>, then the top level
   * domain supports domain privacy; otherwise, <code>false</code>.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of TopLevelDomain
   *
   * @returns {object} metadata of TopLevelDomain
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TopLevelDomain',
      type: {
        name: 'Composite',
        className: 'TopLevelDomain',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: false,
            serializedName: 'kind',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          privacy: {
            required: false,
            serializedName: 'properties.privacy',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = TopLevelDomain;
