/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Options for retrieving the list of top level domain legal agreements.
 *
 */
class TopLevelDomainAgreementOption {
  /**
   * Create a TopLevelDomainAgreementOption.
   * @member {boolean} [includePrivacy] If <code>true</code>, then the list of
   * agreements will include agreements for domain privacy as well; otherwise,
   * <code>false</code>.
   * @member {boolean} [forTransfer] If <code>true</code>, then the list of
   * agreements will include agreements for domain transfer as well; otherwise,
   * <code>false</code>.
   */
  constructor() {
  }

  /**
   * Defines the metadata of TopLevelDomainAgreementOption
   *
   * @returns {object} metadata of TopLevelDomainAgreementOption
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TopLevelDomainAgreementOption',
      type: {
        name: 'Composite',
        className: 'TopLevelDomainAgreementOption',
        modelProperties: {
          includePrivacy: {
            required: false,
            serializedName: 'includePrivacy',
            type: {
              name: 'Boolean'
            }
          },
          forTransfer: {
            required: false,
            serializedName: 'forTransfer',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = TopLevelDomainAgreementOption;
