/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Triggered Web Job History. List of Triggered Web Job Run Information
 * elements.
 *
 * @extends models['ProxyOnlyResource']
 */
class TriggeredJobHistory extends models['ProxyOnlyResource'] {
  /**
   * Create a TriggeredJobHistory.
   * @member {array} [runs] List of triggered web job runs.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of TriggeredJobHistory
   *
   * @returns {object} metadata of TriggeredJobHistory
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TriggeredJobHistory',
      type: {
        name: 'Composite',
        className: 'TriggeredJobHistory',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: false,
            serializedName: 'kind',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          runs: {
            required: false,
            serializedName: 'properties.runs',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'TriggeredJobRunElementType',
                  type: {
                    name: 'Composite',
                    className: 'TriggeredJobRun'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = TriggeredJobHistory;
