/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * User crendentials used for publishing activity.
 *
 * @extends models['ProxyOnlyResource']
 */
class User extends models['ProxyOnlyResource'] {
  /**
   * Create a User.
   * @member {string} publishingUserName Username used for publishing.
   * @member {string} [publishingPassword] Password used for publishing.
   * @member {string} [publishingPasswordHash] Password hash used for
   * publishing.
   * @member {string} [publishingPasswordHashSalt] Password hash salt used for
   * publishing.
   * @member {string} [scmUri] Url of SCM site.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of User
   *
   * @returns {object} metadata of User
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'User',
      type: {
        name: 'Composite',
        className: 'User',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: false,
            serializedName: 'kind',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          publishingUserName: {
            required: true,
            serializedName: 'properties.publishingUserName',
            type: {
              name: 'String'
            }
          },
          publishingPassword: {
            required: false,
            serializedName: 'properties.publishingPassword',
            type: {
              name: 'String'
            }
          },
          publishingPasswordHash: {
            required: false,
            serializedName: 'properties.publishingPasswordHash',
            type: {
              name: 'String'
            }
          },
          publishingPasswordHashSalt: {
            required: false,
            serializedName: 'properties.publishingPasswordHashSalt',
            type: {
              name: 'String'
            }
          },
          scmUri: {
            required: false,
            serializedName: 'properties.scmUri',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = User;
