/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes the result of resource validation.
 *
 */
class ValidateResponse {
  /**
   * Create a ValidateResponse.
   * @member {string} [status] Result of validation.
   * @member {object} [error] Error details for the case when validation fails.
   * @member {string} [error.code] Validation error code.
   * @member {string} [error.message] Validation error message.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ValidateResponse
   *
   * @returns {object} metadata of ValidateResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ValidateResponse',
      type: {
        name: 'Composite',
        className: 'ValidateResponse',
        modelProperties: {
          status: {
            required: false,
            serializedName: 'status',
            type: {
              name: 'String'
            }
          },
          error: {
            required: false,
            serializedName: 'error',
            type: {
              name: 'Composite',
              className: 'ValidateResponseError'
            }
          }
        }
      }
    };
  }
}

module.exports = ValidateResponse;
