/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Specification for using a Virtual Network.
 *
 */
class VirtualNetworkProfile {
  /**
   * Create a VirtualNetworkProfile.
   * @member {string} [id] Resource id of the Virtual Network.
   * @member {string} [name] Name of the Virtual Network (read-only).
   * @member {string} [type] Resource type of the Virtual Network (read-only).
   * @member {string} [subnet] Subnet within the Virtual Network.
   */
  constructor() {
  }

  /**
   * Defines the metadata of VirtualNetworkProfile
   *
   * @returns {object} metadata of VirtualNetworkProfile
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VirtualNetworkProfile',
      type: {
        name: 'Composite',
        className: 'VirtualNetworkProfile',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          subnet: {
            required: false,
            serializedName: 'subnet',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = VirtualNetworkProfile;
