/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The Virtual Network gateway contract. This is used to give the Virtual
 * Network gateway access to the VPN package.
 *
 * @extends models['ProxyOnlyResource']
 */
class VnetGateway extends models['ProxyOnlyResource'] {
  /**
   * Create a VnetGateway.
   * @member {string} [vnetName] The Virtual Network name.
   * @member {string} vpnPackageUri The URI where the VPN package can be
   * downloaded.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of VnetGateway
   *
   * @returns {object} metadata of VnetGateway
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VnetGateway',
      type: {
        name: 'Composite',
        className: 'VnetGateway',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: false,
            serializedName: 'kind',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          vnetName: {
            required: false,
            serializedName: 'properties.vnetName',
            type: {
              name: 'String'
            }
          },
          vpnPackageUri: {
            required: true,
            serializedName: 'properties.vpnPackageUri',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = VnetGateway;
