/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The required set of inputs to validate a VNET
 *
 * @extends models['ProxyOnlyResource']
 */
class VnetParameters extends models['ProxyOnlyResource'] {
  /**
   * Create a VnetParameters.
   * @member {string} [vnetResourceGroup] The Resource Group of the VNET to be
   * validated
   * @member {string} [vnetName] The name of the VNET to be validated
   * @member {string} [vnetSubnetName] The subnet name to be validated
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of VnetParameters
   *
   * @returns {object} metadata of VnetParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VnetParameters',
      type: {
        name: 'Composite',
        className: 'VnetParameters',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: false,
            serializedName: 'kind',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          vnetResourceGroup: {
            required: false,
            serializedName: 'properties.vnetResourceGroup',
            type: {
              name: 'String'
            }
          },
          vnetName: {
            required: false,
            serializedName: 'properties.vnetName',
            type: {
              name: 'String'
            }
          },
          vnetSubnetName: {
            required: false,
            serializedName: 'properties.vnetSubnetName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = VnetParameters;
