/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A class that describes a test that failed during NSG and UDR validation.
 *
 * @extends models['ProxyOnlyResource']
 */
class VnetValidationTestFailure extends models['ProxyOnlyResource'] {
  /**
   * Create a VnetValidationTestFailure.
   * @member {string} [testName] The name of the test that failed.
   * @member {string} [details] The details of what caused the failure, e.g.
   * the blocking rule name, etc.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of VnetValidationTestFailure
   *
   * @returns {object} metadata of VnetValidationTestFailure
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VnetValidationTestFailure',
      type: {
        name: 'Composite',
        className: 'VnetValidationTestFailure',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: false,
            serializedName: 'kind',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          testName: {
            required: false,
            serializedName: 'properties.testName',
            type: {
              name: 'String'
            }
          },
          details: {
            required: false,
            serializedName: 'properties.details',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = VnetValidationTestFailure;
